#!/usr/local/bin/perl
#
#Relay program
#Listen to a client and pass on anything between
#the client and the server
#
#Author: Qing Gong (kingkong@vnet.ibm.com)
#
#Date: 09/20/96
#Date: 04/21/97 (bug fix, get rid of defunct processes)

#sub create_links;

print "Usage: relay.pl relay-port\n";

$relay_port = 9999;
if ($#ARGV == 0) {
   $relay_port = $ARGV[0];
}

$server_port = 6667 ;

$AF_INET = 2;
$SOCKET_STREAM = 1;
$PROTOCOL = 0;
$CLIENT_QUEUE = 10;

select(COMM_SOCK);
$| = 1;
select(stdout);

($name, $aliases, $proto)=getprotobyname('tcp');

socket(SERVER_SOCKET, $AF_INET, $SOCKET_STREAM, $proto) ||
   die "Socket $!\n";

$packed_address = pack('S n a4 x8', $AF_INET, $relay_port, "\0\0\0\0");

bind(SERVER_SOCKET, $packed_address) || die "Bind $!\n";

listen(SERVER_SOCKET, $CLIENT_QUEUE) || die "Listen $!\n";

#($name, $aliases, $len, $address) = gethostbyname("ns2.ensicaen.ismra.fr");
$server_addr = pack('S n a4 x8', $AF_INET, $server_port, "\0\0\0\0");

print "Relay started on port $relay_port ...\n";

while (1) {
   #accept client connection
   accept(NEW_SOCKET, SERVER_SOCKET) || die "Accept $!\n";

   $buf = <NEW_SOCKET>;

   #Display who connects to me
   $name = do gethostbysocket(NEW_SOCKET);

   #log the connection
   chop($buf);
   do write_log("$name connected to: $buf\n");

   print "$name is connecting to server: $buf\n";

   @srvinfo=split(':', $buf);
   $serveraddr = $srvinfo[0];
   $serverport = $srvinfo[1];

   #forward message to the target machine
   do create_links();

   waitpid($ghostpid, $stat);
}

#get client IP/host name by socket handle
sub gethostbysocket {
   $addr = getpeername($_[0]);
   ($d, $d1, $p1, $p2, $p3, $p4) = unpack("S n C4 x8", $addr);
   $addr = pack("C4", $p1, $p2, $p3, $p4);
   if (!(($name, $al, $ty, $len, $add) = gethostbyaddr($addr, AF_INET))) {
      $name = "$p1.$p2.$p3.$p4";
   }
   return $name;
}

#write a server log line
sub write_log {
   ($sec, $min, $hr, $md, $mon, $yr, $wday, $yday, $isdat) = localtime(time);
   $mon++;
   open(FILE_H, ">>server.log");
   printf FILE_H "%02d:%02d:%02d %02d/%02d/%02d > %s",
      $hr, $min, $sec, $mon, $md, $yr, $_[0];
   close(FILE_H);
}

#create a double link for the relay
sub create_links {
   if ($pid = fork) {        #parent process
      if ($temppid = fork) {
         $ghostpid = $temppid;
         exit;
      } elsif (defined $pid) {  #child process
#         print "Open socket to target server ...\n";
         socket(CLIENT_SOCKET, $AF_INET, $SOCKET_STREAM, $proto) ||
            print "Connect to server $!\n";
         ($name, $aliases, $type, $len, $srvip) = gethostbyname($serveraddr);
         ($name, $aliases, $type, $len, $myip) = gethostbyname('local');
         $myaddr = pack('S n a4 x8', $AF_INET, 0, $myip);
         bind(CLIENT_SOCKET, $myaddr) || die "No socket";

         $srvaddr = pack('S n a4 x8', $AF_INET, $serverport, $srvip);

         do {
            $result = connect(CLIENT_SOCKET, $srvaddr);
            if ($result != 1) {
               sleep(1);
            }
         } while($result != 1);

         #no buffer for CLIENT_SOCKET, flush right away
         select(CLIENT_SOCKET);
         $| = 1;
         select(NEW_SOCKET);
         $| = 1;
         select(STDOUT);
         $| = 1;

         #fork another child to do the double link
         if ($pid1 = fork) {
            while ($buf = <NEW_SOCKET>) {
               print CLIENT_SOCKET $buf;
#               print "To target machine: $buf";
            }
            #$host = do gethostbysocket(NEW_SOCKET);
            #close(NEW_SOCKET);
            #do write_log("$host disconnected -- (ircc)\n");
            print "link1 closed\n";
            exit;
         } elsif (defined $pid1) {  #child stuff
            while($buf1 = <CLIENT_SOCKET>) {
               print NEW_SOCKET $buf1;
#               print "From target machine: $buf1\n";
            }
            #close the other link
            $hostc = do gethostbysocket(NEW_SOCKET);
            close(NEW_SOCKET);

            $hostd = do gethostbysocket(CLIENT_SOCKET);
            close(CLIENT_SOCKET);
            do write_log("$hostd(ircd) <=> $hostc(ircc)\n");
            print "link2 closed\n";
            exit;
         }
         exit;
      } elsif ($! =~/No more process/) {
         sleep 5;
         redo create_links;
      } else {
         &die("Can't fork: $!\n");
      }
   }
}

